unit sp_Lib_Delphi;
interface
(*
  -   :
     "Delphi  1:.  "
*)

Uses
  ComObj,
  //Consts,
  
  registry,
  classes,
  windows,
  SysUtils;



// 1:    OLE Automation
function ConnectTo1C(InitStr,NoSplashShow : string) : Variant;
//,     Variant
function YesLinkToVariant(HandleAny : Variant) : boolean;


//    1   
function Load_ListDB_from_Registry(KeyName : string;
                                   List : TStrings;
                                   YesDetect_1Cv7md : boolean) : integer;


implementation


//***************************************************************
function ConnectTo1C(InitStr,NoSplashShow : string) : Variant;
// 1:    OLE Automation
Var
  ResOpen : integer;
begin
  Result:=UnAssigned;
  InitStr:=Trim(InitStr);
  Result := CreateOleObject('V77.Application');
  if YesLinkToVariant(Result) then begin
     ResOpen:=Result.Initialize(Result.RMTrade, InitStr, NoSplashShow);
     if ResOpen>=0 then begin
        Result:=UnAssigned;
     end;
  end;
end;


function YesLinkToVariant(HandleAny : Variant) : boolean;
//,     Variant
begin
 Result:=FALSE;
 if not VarIsEmpty(HandleAny) then Result:=TRUE;
end;
//***************************************************************




function Load_ListDB_from_Registry(KeyName : string;
                                   List : TStrings;
                                   YesDetect_1Cv7md : boolean) : integer;
//    1   
//KeyName -     ,
//  .
// Windows-2000/XP :
//  KeyName= Software\1C\1CV7\7.7\Titles
//  RootKey= HKey_Current_User
//List -      1
//YesDetect_1Cv7md -  TRUE,     1Cv7.md
var
  sNameDB,  //  ( ) 1
  fnMD : string; //   1Cv7.MD
  Reg  : TRegistry;
  i    : integer;
  Yes  : byte;
begin
  Result:=0;
  if List<>NIL then begin
     List.Clear;
     KeyName:=Trim(KeyName);
     if length(KeyName)>0 then begin
        Reg:=TRegistry.Create;
        try
          Reg.RootKey:=HKey_Current_User;

          if Reg.OpenKey(KeyName,False) then begin

             //    
             //( ) 1
             Reg.GetValueNames(List);

             if List.Count>0 then begin
                //---------------------------------
                //    1
                i:=-1;
                while i<(List.Count-1) do
                 begin
                   i:=i+1;
                   Yes  := 0;
                   if YesDetect_1Cv7md then begin
                      //   1Cv7.md
                      //  

                      //   MD- 
                      fnMD := List[I]+'1cv7.md';
                      //,   MD-
                      if FileExists(fnMD) then begin
                         //MD- 
                         Yes:=1;
                      end
                      else begin
                         //MD-  ,   
                         List.Delete(i);
                         i:=i-1;
                      end;
                      
                   end
                   else begin
                      //    1Cv7.md
                      Yes:=1;
                   end;
                   if Yes>0 then begin
                      //   
                      sNameDB:=Trim(Reg.ReadString(List[I]));
                      List[i]:=sNameDB+'='+List[i];
                   end;
                   //Application.ProcessMessages;
                end;
                //---------------------------------

             end;
          end;
          Result:=List.Count;
        finally
          Reg.Free;
        end;
     end;
  end;
end;




end.






